// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'starter.controllers', 'starter.services', 'ngCordova'])

.run(['$ionicPlatform','$location','$rootScope','$ionicHistory','$cordovaToast',
      '$timeout','$cordovaAppVersion', '$ionicPopup', '$http', 'locals',
      //'$ionicLoading','$cordovaFileTransfer', '$cordovaFile', '$cordovaFileOpener2',
    function($ionicPlatform,$location,$rootScope,$ionicHistory,$cordovaToast,
             $timeout,$cordovaAppVersion, $ionicPopup, $http, locals
             //, $ionicLoading,$cordovaFileTransfer, $cordovaFile, $cordovaFileOpener2
    ) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);

    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }
    //检测更新
    var skipUpdate = locals.get("skipUpdate", 0);
    //alert("skipUdate:" + skipUpdate);
    if (skipUpdate == 0) {
      checkUpdate();
      locals.set("skipUpdate", 1);
    }

    //document.addEventListener("menubutton", onHardwareMenuKeyDown, false);
  });

      // 菜单键
      //function onHardwareMenuKeyDown() {
      //  $ionicActionSheet.show({
      //    titleText: '检查更新',
      //    buttons: [
      //      { text: '关于' }
      //    ],
      //    destructiveText: '检查更新',
      //    cancelText: '取消',
      //    cancel: function () {
      //      // add cancel code..
      //    },
      //    destructiveButtonClicked: function () {
      //      //检查更新
      //      checkUpdate();
      //    },
      //    buttonClicked: function (index) {
      //
      //    }
      //  });
      //  $timeout(function () {
      //    hideSheet();
      //  }, 2000);
      //};

      // 检查更新
      function checkUpdate() {
        //alert("start checkUpdte 332");
        //alert("SkipUpdate: " + Profile.skipUpdate + "updateInfo: " + $rootScope.updateInfo);
        //if(skipUpdate !== true){
          $http.get('http://www.51paima.com/app/ver.json')
            .success(function(data){
              //.then(function(data){
              $rootScope.serverAppVersion = data.verInfo;//服务器 版本
              //console.log("====>>服务器"+serverAppVersion);
              //alert("====>>服务器1: "+$rootScope.serverAppVersion);
              $cordovaAppVersion.getVersionNumber().then(function(version) {
                //console.log("version=====本机>>>"+version+"====>>服务器"+serverAppVersion);
                //alert("version=====本机>>>"+version+"====>>服务器"+serverAppVersion);
                if (version != $rootScope.serverAppVersion) {
                  $rootScope.updateInfo = data.upInfo;
                  //alert("updateInfo: " + $rootScope.updateInfo);
                  showUpdateConfirm();
                }
              });
            });
        //}



        //var serverAppVersion = "1.0.2"; //从服务端获取最新版本
        ////获取版本
        //cordova.getAppVersion.getVersionNumber().then(function (version) {
        //  //如果本地与服务端的APP版本不符合
        //  alert("version: " + version);
        //  if (version != serverAppVersion) {
        //    showUpdateConfirm();
        //  }
        //});
      }

      // 显示是否更新对话框
      function showUpdateConfirm() {

        // 一个提示对话框
          var alertPopup = $ionicPopup.alert({
            title: '新版本 ' + $rootScope.serverAppVersion + ' 发布了，快去升级吧！',
            template: $rootScope.updateInfo
          });
          alertPopup.then(function(res) {
            //console.log('Thank you for not eating my delicious ice cream cone');
            //skipUpdate = true;
            //alert("升级取消1" + skipUpdate);
          });

        //var confirmPopup = $ionicPopup.confirm({
        //  title: '版本升级',
        //  //template: '1.xxxx;</br>2.xxxxxx;</br>3.xxxxxx;</br>4.xxxxxx', //从服务端获取更新的内容
        //  //template: '1. 提升版本稳定性;</br>2.UI优化及错误修正', //从服务端获取更新的内容
        //  template: $rootScope.updateInfo, //从服务端获取更新的内容
        //  cancelText: '取消',
        //  okText: '升级'
        //});
        //confirmPopup.then(function (res) {
        //  if (res) {
        //    $ionicLoading.show({
        //      template: "已经下载：0%"
        //    });
        //    var url = "http://www.51paima.com/app/seclabel.apk"; //可以从服务端获取更新APP的路径
        //    //var targetPath = "file:///storage/sdcard0/Download/seclabel.apk"; //APP下载存放的路径，可以使用cordova file插件进行相关配置
        //    var targetPath = cordova.file.externalApplicationStorageDirectory + "files/seclabel.apk"; //APP下载存放的路径，可以使用cordova file插件进行相关配置
        //    var trustHosts = true
        //    var options = {};
        //    //alert("path: " + targetPath);
        //    $cordovaFileTransfer.download(url, targetPath, options, trustHosts).then(function (result) {
        //      // 打开下载下来的APP
        //      $cordovaFileOpener2.open(targetPath, 'application/vnd.android.package-archive'
        //      ).then(function () {
        //          // 成功
        //        }, function (err) {
        //          // 错误
        //        });
        //      $ionicLoading.hide();
        //    }, function (err) {
        //      alert('下载失败');
        //    }, function (progress) {
        //      //进度，这里使用文字显示下载百分比
        //      $timeout(function () {
        //        var downloadProgress = (progress.loaded / progress.total) * 100;
        //        $ionicLoading.show({
        //          template: "已经下载：" + Math.floor(downloadProgress) + "%"
        //        });
        //        if (downloadProgress > 99) {
        //          $ionicLoading.hide();
        //        }
        //      })
        //    });
        //  } else {
        //    // 取消更新
        //    //$rootScope.skipUpdate = true;
        //    //alert("升级取消1");
        //  }
        //});
      }

    /********************双击退出start********************/
    $ionicPlatform.registerBackButtonAction(function (e) {
        if ($rootScope.backButtonPressedOnceToExit) {
          locals.set("skipUpdate", 0);
          ionic.Platform.exitApp();
        } else {
          $rootScope.backButtonPressedOnceToExit = true;
          $cordovaToast.showShortBottom('再按一次退出系统');
          setTimeout(function () {
            $rootScope.backButtonPressedOnceToExit = false;
          }, 2000);
        }
    }, 101);
    /********************双击退出end********************/
}])

.config(function($ionicConfigProvider) {
    $ionicConfigProvider.platform.ios.tabs.style('standard');
    $ionicConfigProvider.platform.ios.tabs.position('bottom');
    $ionicConfigProvider.platform.android.tabs.style('standard');
    $ionicConfigProvider.platform.android.tabs.position('standard');

    $ionicConfigProvider.platform.ios.navBar.alignTitle('center');
    $ionicConfigProvider.platform.android.navBar.alignTitle('left');

    $ionicConfigProvider.platform.ios.backButton.previousTitleText('').icon('ion-ios-arrow-thin-left');
    $ionicConfigProvider.platform.android.backButton.previousTitleText('').icon('ion-android-arrow-back');

    $ionicConfigProvider.platform.ios.views.transition('ios');
    $ionicConfigProvider.platform.android.views.transition('android');

});
